using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Security;

namespace Decal.Interop.Inject;

[ComImport]
[InterfaceType(1)]
[SuppressUnmanagedCodeSecurity]
[Guid("0B43A5E9-2ED4-4A0C-AED1-552B9E3A23B3")]
public interface IPlugin
{
	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	void Initialize([MarshalAs(UnmanagedType.Interface)] PluginSite pSite, int nID);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	void Terminate();

	[DispId(1610678274)]
	string FriendlyName
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		[return: MarshalAs(UnmanagedType.BStr)]
		get;
	}
}
